// MikuMikuTicklep
// ZT[ʐMNCAg

#include <stdio.h>
#include <string.h>
#include <winsock2.h>
#include "SensorClient.h"

int ReadBufAsInt(int nBytes, char *buf){
  int iData=0;
  for(int i=0;i<nBytes;i++){
    iData=((iData<<8)|(((unsigned char *)buf)[i]));
  }
  return iData;
}

float ReadBufAsFloat(char *buf){
  int iData=ReadBufAsInt(4,buf);
  return *((float *)(&iData));
}

SensorClientHand::SensorClientHand(){
  fingers=nullptr;
}

SensorClientHand::~SensorClientHand(){
  delete[] fingers;
}

SensorClient::SensorClient(char *dstAddr,int iPort){
  iError=0;
  state=0;
  capRcvbuf=1024;
  rcvnbytes=0;
  rcvidx=0;
  rcvbuf=new char[capRcvbuf];
  sndnbytes=0;
  sndidx=0;
  nHand=0;
  hands=nullptr;
  sizeQCommand=0;
  capQCommand=8;
  qCommand=new char *[capQCommand];
  sock = socket(AF_INET, SOCK_STREAM, 0);
  struct sockaddr_in server;
  server.sin_family = AF_INET;
  server.sin_port = htons(iPort);
  server.sin_addr.S_un.S_addr = inet_addr(dstAddr);
  if (server.sin_addr.S_un.S_addr == 0xffffffff){
    struct hostent *host;
    host = gethostbyname(dstAddr);
    if (host == NULL){
      // T[o[Ȃ
      iError=1;
    }
    server.sin_addr.S_un.S_addr = *(unsigned int *)host->h_addr_list[0];
  }
  if(iError==0){
    if(connect(sock, (struct sockaddr *)&server, sizeof(server))!=0){
      // ڑs
      iError=2;
    }
    u_long val=1; // Non-blockng mode
    ioctlsocket(sock, FIONBIO, &val);
  }
}

SensorClient::~SensorClient(){
  closesocket(sock);
  delete[] rcvbuf;
  for(int i=0;i<sizeQCommand;i++) delete[] qCommand[i];
  delete[] qCommand;
  delete[] hands;
}

void SensorClient::WriteIntSndBuf(int *idx,int nBytes,int iData){
  for(int i=0;i<nBytes;i++){
    if((*idx)>=capSndbuf) break;
    sndbuf[*idx]=(0xff & (iData>>(8*(nBytes-1-i))));
    (*idx)++;
  }
}

void SensorClient::WriteCStrSndBuf(int *idx,char *str){
  int len=strlen(str);
  for(int i=0;i<len+1;i++){
    if((*idx)>=capSndbuf) break;
    sndbuf[*idx]=((unsigned char *)str)[i];
    (*idx)++;
  }
}

int SensorClient::ReadRcvBufAsInt(int nBytes,int *idx){
  int iData=ReadBufAsInt(nBytes,rcvbuf+(*idx));
  (*idx)+=nBytes;
  return iData;
}

float SensorClient::ReadRcvBufAsFloat(int *idx){
  float fData=ReadBufAsFloat(rcvbuf+(*idx));
  (*idx)+=4;
  return fData;
}

int SensorClient::GetSizeQCommand(){
  return sizeQCommand;
}

int SensorClient::PostCommand(char *command){
  int iErr=0;
  int iLen=strlen(command);
  if(iLen>(capSndbuf-3)) iErr=1;
  else{
    if(sizeQCommand>=capQCommand){
      int capQCommand2=capQCommand+8;
      char **qCommand2=new char *[capQCommand2];
      for(int i=0;i<capQCommand;i++) qCommand2[i]=qCommand[i];
      delete qCommand;
      qCommand=qCommand2;
      capQCommand=capQCommand2;
    }
    qCommand[sizeQCommand]=new char[iLen+1];
    strcpy(qCommand[sizeQCommand],command);
    sizeQCommand++;
    forward();
  }
  return iErr;
}

void SensorClient::forward(){
  int m;
  int loopcont=1;
  while(loopcont){
    if(state==0){ // R}hM
      if(sizeQCommand <= 0) loopcont=0;
      else{
        int idx=2;
        WriteCStrSndBuf(&idx,qCommand[0]);
        int idxZero=0;
        WriteIntSndBuf(&idxZero,2,idx-2);
        sndnbytes=idx;
        delete qCommand[0];
        for(int i=1;i<sizeQCommand;i++) qCommand[i-1]=qCommand[i];
        sizeQCommand--;
        sndidx=0;
        state=1;
      }
    } else if(state==1){ // R}hM
      if(sndidx>=sndnbytes){
        state=2;
        rcvidx=0;
      } else{
        m=send(sock,sndbuf+sndidx,sndnbytes-sndidx,0);
        if(m>0) sndidx+=m;
        else{
          loopcont=0;
          if(m==0) iError=3;
          else if(WSAGetLastError() != WSAEWOULDBLOCK) iError=4;
        }
      }
    } else if(state==2){ // ʎMJn
      if(rcvidx>=2){
        state=3;
        rcvnbytes=ReadBufAsInt(2,rcvbuf)+2;
        if(rcvnbytes>=capRcvbuf){
          int capRcvbuf2=rcvnbytes+1024;
          char *rcvbuf2=new char[capRcvbuf2];
          memcpy(rcvbuf2,rcvbuf,2);
          delete[] rcvbuf;
          rcvbuf=rcvbuf2;
          capRcvbuf=capRcvbuf2;
        }
      } else{
        m=recv(sock,rcvbuf+rcvidx,2-rcvidx,0);
        if(m>0) rcvidx+=m;
        else{
          loopcont=0;
          if(m==0) iError=5;
          else if(WSAGetLastError() != WSAEWOULDBLOCK) iError=6;
        }
      }
    } else if(state==3){ // ʎM
      if(rcvidx>=rcvnbytes){
        DoAction();
        state=0;
      } else{
        m=recv(sock,rcvbuf+rcvidx,rcvnbytes-rcvidx,0);
        if(m>0) rcvidx+=m;
        else{
          loopcont=0;
          if(m==0) iError=5;
          else if(WSAGetLastError() != WSAEWOULDBLOCK) iError=6;
        }
      }
    }
    if(iError!=0) loopcont=0;
  }
}

int SensorClient::CmpResName(char *resName){
  int nameLen=strlen(resName);
  if(rcvnbytes<2+nameLen) return(-1);
  return strncmp(rcvbuf+2,resName,nameLen);
}

void SensorClient::DoAction(){
  char *actionName="HandData:";
  if(CmpResName(actionName)==0){
    int idx=2+strlen(actionName);
    delete[] hands;
    hands=nullptr;
    ParseHandData(&idx);
  }
}

void SensorClient::ParseHandData(int *idx){
  nHand=ReadRcvBufAsInt(4,idx);
  hands=new SensorClientHand[nHand];
  for(int iHand=0;iHand<nHand;iHand++){
    hands[iHand].id=ReadRcvBufAsInt(4,idx);
    hands[iHand].isRight=ReadRcvBufAsInt(4,idx);
    hands[iHand].palmPosition[0]=ReadRcvBufAsFloat(idx);
    hands[iHand].palmPosition[1]=ReadRcvBufAsFloat(idx);
    hands[iHand].palmPosition[2]=ReadRcvBufAsFloat(idx);
    hands[iHand].direction[0]=ReadRcvBufAsFloat(idx);
    hands[iHand].direction[1]=ReadRcvBufAsFloat(idx);
    hands[iHand].direction[2]=ReadRcvBufAsFloat(idx);
    hands[iHand].palmNormal[0]=ReadRcvBufAsFloat(idx);
    hands[iHand].palmNormal[1]=ReadRcvBufAsFloat(idx);
    hands[iHand].palmNormal[2]=ReadRcvBufAsFloat(idx);
    int nFinger=ReadRcvBufAsInt(4,idx);
    hands[iHand].nFinger=nFinger;
    hands[iHand].fingers=new SensorClientFinger[nFinger];
    for(int iFinger=0;iFinger<nFinger;iFinger++){
      hands[iHand].fingers[iFinger].type=ReadRcvBufAsInt(4,idx);
      hands[iHand].fingers[iFinger].tipPosition[0]=ReadRcvBufAsFloat(idx);
      hands[iHand].fingers[iFinger].tipPosition[1]=ReadRcvBufAsFloat(idx);
      hands[iHand].fingers[iFinger].tipPosition[2]=ReadRcvBufAsFloat(idx);
      for(int iJoint=0;iJoint<4;iJoint++){
        hands[iHand].fingers[iFinger].joints[iJoint].xBasis[0]=ReadRcvBufAsFloat(idx);
        hands[iHand].fingers[iFinger].joints[iJoint].xBasis[1]=ReadRcvBufAsFloat(idx);
        hands[iHand].fingers[iFinger].joints[iJoint].xBasis[2]=ReadRcvBufAsFloat(idx);
        hands[iHand].fingers[iFinger].joints[iJoint].yBasis[0]=ReadRcvBufAsFloat(idx);
        hands[iHand].fingers[iFinger].joints[iJoint].yBasis[1]=ReadRcvBufAsFloat(idx);
        hands[iHand].fingers[iFinger].joints[iJoint].yBasis[2]=ReadRcvBufAsFloat(idx);
        hands[iHand].fingers[iFinger].joints[iJoint].zBasis[0]=ReadRcvBufAsFloat(idx);
        hands[iHand].fingers[iFinger].joints[iJoint].zBasis[1]=ReadRcvBufAsFloat(idx);
        hands[iHand].fingers[iFinger].joints[iJoint].zBasis[2]=ReadRcvBufAsFloat(idx);
      }
    }
  }
}

int SensorClient::HandDataReq(){
  if(GetSizeQCommand()<=0) return PostCommand("HandDataReq");
  else return -1;
}

int SensorClient::isWorking(){
  return (state!=0);
}
