// PMXf[^ǂݍ
//(QlFPMXGfB^thLg"PMXdl.txt")

#include <Windows.h>
#include <stdio.h>
#include <string.h>
#include "pmx.h"

int fget_bytes_as_int(int nbytes,FILE *infile){
  int i,rtn,wk;

  rtn=0;
  for(i=0;i<nbytes;i++){
    wk=fgetc(infile);
    if(wk!=EOF) rtn |= wk<<(8*i);
  }
  return rtn;
}

void fread_TextBuf(TextBuf *tbuf,FILE *infile,BYTE bEncode){
  int nb;
  char *aByte=nullptr;

  nb=fget_bytes_as_int(4,infile);
  if(nb>0){
    aByte=new char[nb];
    fread(aByte,sizeof(BYTE),nb,infile);
  }
  if(bEncode){ // UTF-8
    tbuf->nwc=MultiByteToWideChar(CP_UTF8,0,aByte,nb,nullptr,0)+1;
    tbuf->aWChar=new WCHAR[tbuf->nwc];
    MultiByteToWideChar(CP_UTF8,0,aByte,nb,tbuf->aWChar,tbuf->nwc);
  } else{ // UTF-16
    tbuf->nwc=nb/sizeof(WCHAR)+1;
    tbuf->aWChar=new WCHAR[tbuf->nwc];
    memcpy(tbuf->aWChar,aByte,sizeof(WCHAR)*(tbuf->nwc-1));
  }
  tbuf->aWChar[tbuf->nwc-1]=L'\0';
  if(aByte) delete[] aByte;
}

t_pmx_data *create_pmx_data(char *pathname,char **rtn_err_str){
  t_pmx_data *pmx_data=nullptr;
  FILE *infile=nullptr;
  char *err_str=nullptr;
  int err_flg=0;
  int i,j;
  float fWTotal;
  BYTE bEncode;

  if((infile=fopen(pathname,"rb"))==nullptr){
    err_str="PMXt@CJ܂";
    err_flg=1;
  }
  else{
    pmx_data = new t_pmx_data;
    ZeroMemory(pmx_data, sizeof(t_pmx_data));
    // wb_
    fread(&(pmx_data->magic),sizeof(char),4,infile);
    fread(&(pmx_data->version),sizeof(float),1,infile);
    fread(&(pmx_data->fmtinfo_cnt),sizeof(BYTE),1,infile);
    fread(&(pmx_data->fmtinfo_encode),sizeof(BYTE),1,infile);
    bEncode=pmx_data->fmtinfo_encode;
    fread(&(pmx_data->fmtinfo_append_uv_count),sizeof(BYTE),1,infile);
    fread(&(pmx_data->fmtinfo_vertex_index_size),sizeof(BYTE),1,infile);
    fread(&(pmx_data->fmtinfo_texture_index_size),sizeof(BYTE),1,infile);
    fread(&(pmx_data->fmtinfo_material_index_size),sizeof(BYTE),1,infile);
    fread(&(pmx_data->fmtinfo_bone_index_size),sizeof(BYTE),1,infile);
    fread(&(pmx_data->fmtinfo_morph_index_size),sizeof(BYTE),1,infile);
    fread(&(pmx_data->fmtinfo_rigidbody_index_size),sizeof(BYTE),1,infile);
    // f
    fread_TextBuf(&(pmx_data->model_name),infile,bEncode);
    fread_TextBuf(&(pmx_data->model_name_eg),infile,bEncode);
    fread_TextBuf(&(pmx_data->comment),infile,bEncode);
    fread_TextBuf(&(pmx_data->comment_eg),infile,bEncode);
    // _
    pmx_data->vert_count=fget_bytes_as_int(4,infile);
    if(pmx_data->vert_count>0)
      pmx_data->vertex = new t_pmx_vertex[pmx_data->vert_count];
    ZeroMemory(pmx_data->vertex, sizeof(t_pmx_vertex)*pmx_data->vert_count);
    for(i=0;(i<pmx_data->vert_count)&&(err_flg==0);i++){
      fread(&(pmx_data->vertex[i].pos),sizeof(float3),1,infile);
      fread(&(pmx_data->vertex[i].normal_vec),sizeof(float3),1,infile);
      fread(&(pmx_data->vertex[i].uv),sizeof(float2),1,infile);
      if(pmx_data->fmtinfo_append_uv_count>0){
        pmx_data->vertex[i].append_uv = new float4[pmx_data->fmtinfo_append_uv_count];
        fread(pmx_data->vertex[i].append_uv,sizeof(float4),
              pmx_data->fmtinfo_append_uv_count,infile);
      }
      fread(&(pmx_data->vertex[i].deform),sizeof(BYTE),1,infile);
      if(pmx_data->vertex[i].deform==0){ // BDEF1
        pmx_data->vertex[i].deform_data = new t_pmx_deform_BDEF1;
        ((t_pmx_deform_BDEF1 *)(pmx_data->vertex[i].deform_data))->bone_index=
          fget_bytes_as_int(pmx_data->fmtinfo_bone_index_size,infile);
      } else if(pmx_data->vertex[i].deform==1){ // BDEF2
        pmx_data->vertex[i].deform_data = new t_pmx_deform_BDEF2;
        ((t_pmx_deform_BDEF2 *)(pmx_data->vertex[i].deform_data))->bone_index1=
          fget_bytes_as_int(pmx_data->fmtinfo_bone_index_size,infile);
        ((t_pmx_deform_BDEF2 *)(pmx_data->vertex[i].deform_data))->bone_index2=
          fget_bytes_as_int(pmx_data->fmtinfo_bone_index_size,infile);
        fread(&(((t_pmx_deform_BDEF2 *)(pmx_data->vertex[i].deform_data))->bone_weight),
              sizeof(float),1,infile);
      } else if((pmx_data->vertex[i].deform==2)||
                (pmx_data->vertex[i].deform==4)){ // BDEF4 or QDEF
        pmx_data->vertex[i].deform_data = new t_pmx_deform_BDEF4;
        ((t_pmx_deform_BDEF4 *)(pmx_data->vertex[i].deform_data))->bone_index1=
          fget_bytes_as_int(pmx_data->fmtinfo_bone_index_size,infile);
        ((t_pmx_deform_BDEF4 *)(pmx_data->vertex[i].deform_data))->bone_index2=
          fget_bytes_as_int(pmx_data->fmtinfo_bone_index_size,infile);
        ((t_pmx_deform_BDEF4 *)(pmx_data->vertex[i].deform_data))->bone_index3=
          fget_bytes_as_int(pmx_data->fmtinfo_bone_index_size,infile);
        ((t_pmx_deform_BDEF4 *)(pmx_data->vertex[i].deform_data))->bone_index4=
          fget_bytes_as_int(pmx_data->fmtinfo_bone_index_size,infile);
        fread(&(((t_pmx_deform_BDEF4 *)(pmx_data->vertex[i].deform_data))->bone_weight1),
              sizeof(float),1,infile);
        fread(&(((t_pmx_deform_BDEF4 *)(pmx_data->vertex[i].deform_data))->bone_weight2),
              sizeof(float),1,infile);
        fread(&(((t_pmx_deform_BDEF4 *)(pmx_data->vertex[i].deform_data))->bone_weight3),
              sizeof(float),1,infile);
        fread(&(((t_pmx_deform_BDEF4 *)(pmx_data->vertex[i].deform_data))->bone_weight4),
              sizeof(float),1,infile);
        // EFCgl̍v1.0ɂȂ悤ɒ
        fWTotal=((t_pmx_deform_BDEF4 *)(pmx_data->vertex[i].deform_data))->bone_weight1+
          ((t_pmx_deform_BDEF4 *)(pmx_data->vertex[i].deform_data))->bone_weight2+
            ((t_pmx_deform_BDEF4 *)(pmx_data->vertex[i].deform_data))->bone_weight3+
              ((t_pmx_deform_BDEF4 *)(pmx_data->vertex[i].deform_data))->bone_weight4;
        ((t_pmx_deform_BDEF4 *)(pmx_data->vertex[i].deform_data))->bone_weight1/=fWTotal;
        ((t_pmx_deform_BDEF4 *)(pmx_data->vertex[i].deform_data))->bone_weight2/=fWTotal;
        ((t_pmx_deform_BDEF4 *)(pmx_data->vertex[i].deform_data))->bone_weight3/=fWTotal;
        ((t_pmx_deform_BDEF4 *)(pmx_data->vertex[i].deform_data))->bone_weight4/=fWTotal;
      } else if(pmx_data->vertex[i].deform==3){ // SDEF
        pmx_data->vertex[i].deform_data = new t_pmx_deform_SDEF;
        ((t_pmx_deform_SDEF *)(pmx_data->vertex[i].deform_data))->bone_index1=
          fget_bytes_as_int(pmx_data->fmtinfo_bone_index_size,infile);
        ((t_pmx_deform_SDEF *)(pmx_data->vertex[i].deform_data))->bone_index2=
          fget_bytes_as_int(pmx_data->fmtinfo_bone_index_size,infile);
        fread(&(((t_pmx_deform_SDEF *)(pmx_data->vertex[i].deform_data))->bone_weight),
              sizeof(float),1,infile);
        fread(&(((t_pmx_deform_SDEF *)(pmx_data->vertex[i].deform_data))->sdef_c),
              sizeof(float3),1,infile);
        fread(&(((t_pmx_deform_SDEF *)(pmx_data->vertex[i].deform_data))->sdef_r0),
              sizeof(float3),1,infile);
        fread(&(((t_pmx_deform_SDEF *)(pmx_data->vertex[i].deform_data))->sdef_r1),
              sizeof(float3),1,infile);
      } else{
        err_str="sȃEFCgό`";
        err_flg=1;
      }
      if(err_flg==0){
        fread(&(pmx_data->vertex[i].edge_magnification),sizeof(float),1,infile);
      }
    }
  }
  if(err_flg==0){
    // 
    pmx_data->face_vert_count=fget_bytes_as_int(4,infile);
    if(pmx_data->face_vert_count>0)
      pmx_data->face_vert_index = new DWORD[pmx_data->face_vert_count];
    for(i=0;i<pmx_data->face_vert_count;i++){
      pmx_data->face_vert_index[i]=fget_bytes_as_int(pmx_data->fmtinfo_vertex_index_size,infile);
    }
    // eNX`
    pmx_data->texture_count=fget_bytes_as_int(4,infile);
    if(pmx_data->texture_count>0)
      pmx_data->texture_path = new TextBuf[pmx_data->texture_count];
    for(i=0;i<pmx_data->texture_count;i++){
      fread_TextBuf(&(pmx_data->texture_path[i]),infile,bEncode);
    }
    // ގ
    pmx_data->material_count=fget_bytes_as_int(4,infile);
    if(pmx_data->material_count>0)
      pmx_data->material = new t_pmx_material[pmx_data->material_count];
    for(i=0;i<pmx_data->material_count;i++){
      fread_TextBuf(&(pmx_data->material[i].material_name),infile,bEncode);
      fread_TextBuf(&(pmx_data->material[i].material_name_eg),infile,bEncode);
      fread(&(pmx_data->material[i].diffuse_color),sizeof(float4),1,infile);
      fread(&(pmx_data->material[i].specular_color),sizeof(float3),1,infile);
      fread(&(pmx_data->material[i].specularity),sizeof(float),1,infile);
      fread(&(pmx_data->material[i].ambient_color),sizeof(float3),1,infile);
      fread(&(pmx_data->material[i].draw_flags),sizeof(BYTE),1,infile);
      fread(&(pmx_data->material[i].edge_color),sizeof(float4),1,infile);
      fread(&(pmx_data->material[i].edge_size),sizeof(float),1,infile);
      pmx_data->material[i].texture_index=
        fget_bytes_as_int(pmx_data->fmtinfo_texture_index_size,infile);
      pmx_data->material[i].sphere_index=
        fget_bytes_as_int(pmx_data->fmtinfo_texture_index_size,infile);
      fread(&(pmx_data->material[i].sphere_mode),sizeof(BYTE),1,infile);
      fread(&(pmx_data->material[i].toon_flag),sizeof(BYTE),1,infile);
      if(pmx_data->material[i].toon_flag==0)
        pmx_data->material[i].toon_index=
          fget_bytes_as_int(pmx_data->fmtinfo_texture_index_size,infile);
      else
        pmx_data->material[i].toon_index=fget_bytes_as_int(1,infile);
      fread_TextBuf(&(pmx_data->material[i].memo),infile,bEncode);
      pmx_data->material[i].face_vert_count=fget_bytes_as_int(4,infile);
    }
    // {[
    pmx_data->bone_count=fget_bytes_as_int(4,infile);
    if(pmx_data->bone_count>0)
      pmx_data->bone = new t_pmx_bone[pmx_data->bone_count];
    ZeroMemory(pmx_data->bone, sizeof(t_pmx_bone)*pmx_data->bone_count);
    for(i=0;i<pmx_data->bone_count;i++){
      fread_TextBuf(&(pmx_data->bone[i].bone_name),infile,bEncode);
      fread_TextBuf(&(pmx_data->bone[i].bone_name_eg),infile,bEncode);
      fread(&(pmx_data->bone[i].pos),sizeof(float3),1,infile);
      pmx_data->bone[i].parent_bone_index=
        fget_bytes_as_int(pmx_data->fmtinfo_bone_index_size,infile);
      pmx_data->bone[i].deform_level=fget_bytes_as_int(4,infile);
      fread(&(pmx_data->bone[i].bone_flags),sizeof(WORD),1,infile);
      if(pmx_data->bone[i].bone_flags&0x0001){ // ڑ{[Ŏw
        (pmx_data->bone[i].bone_connection.bone_index)=
          fget_bytes_as_int(pmx_data->fmtinfo_bone_index_size,infile);
      } else{ // ڑWItZbgŎw
        fread(&(pmx_data->bone[i].bone_connection.offset),sizeof(float3),1,infile);
      }
      if(pmx_data->bone[i].bone_flags&0x0300){ // ]t^͈ړt^
        pmx_data->bone[i].give_bone_index=
          fget_bytes_as_int(pmx_data->fmtinfo_bone_index_size,infile);
        fread(&(pmx_data->bone[i].give_rate),sizeof(float),1,infile);
      }
      if(pmx_data->bone[i].bone_flags&0x0400){ // Œ
        fread(&(pmx_data->bone[i].locked_axis),sizeof(float3),1,infile);
      }
      if(pmx_data->bone[i].bone_flags&0x0800){ // [J
        fread(&(pmx_data->bone[i].local_x_axis),sizeof(float3),1,infile);
        fread(&(pmx_data->bone[i].local_z_axis),sizeof(float3),1,infile);
      }
      if(pmx_data->bone[i].bone_flags&0x2000){ // Oό`
        pmx_data->bone[i].key=fget_bytes_as_int(4,infile);
      }
      if(pmx_data->bone[i].bone_flags&0x0020){ // Oό`
        pmx_data->bone[i].ik_data= new t_pmx_ik_data;
        ZeroMemory(pmx_data->bone[i].ik_data,sizeof(t_pmx_ik_data));
        pmx_data->bone[i].ik_data->ik_target_bone_index=
          fget_bytes_as_int(pmx_data->fmtinfo_bone_index_size,infile);
        pmx_data->bone[i].ik_data->iterations=fget_bytes_as_int(4,infile);
        fread(&(pmx_data->bone[i].ik_data->control_angle),sizeof(float),1,infile);
        pmx_data->bone[i].ik_data->ik_link_count=fget_bytes_as_int(4,infile);
        if(pmx_data->bone[i].ik_data->ik_link_count>0)
          pmx_data->bone[i].ik_data->ik_link=
            new t_pmx_ik_link[pmx_data->bone[i].ik_data->ik_link_count];
        ZeroMemory(pmx_data->bone[i].ik_data->ik_link,
                   sizeof(t_pmx_ik_link)*pmx_data->bone[i].ik_data->ik_link_count);
        for(j=0;j<pmx_data->bone[i].ik_data->ik_link_count;j++){
          pmx_data->bone[i].ik_data->ik_link[j].bone_index=
            fget_bytes_as_int(pmx_data->fmtinfo_bone_index_size,infile);
          fread(&(pmx_data->bone[i].ik_data->ik_link[j].angle_constrain),sizeof(BYTE),1,infile);
          if(pmx_data->bone[i].ik_data->ik_link[j].angle_constrain){
            fread(&(pmx_data->bone[i].ik_data->ik_link[j].l_angle),sizeof(float3),1,infile);
            fread(&(pmx_data->bone[i].ik_data->ik_link[j].u_angle),sizeof(float3),1,infile);
          }
        }
      }
    }
    // [t
    pmx_data->morph_count=fget_bytes_as_int(4,infile);
    if(pmx_data->morph_count>0)
      pmx_data->morph = new t_pmx_morph[pmx_data->morph_count];
    ZeroMemory(pmx_data->morph, sizeof(t_pmx_morph)*pmx_data->morph_count);
    for(i=0;i<pmx_data->morph_count;i++){
      fread_TextBuf(&(pmx_data->morph[i].morph_name),infile,bEncode);
      fread_TextBuf(&(pmx_data->morph[i].morph_name_eg),infile,bEncode);
      fread(&(pmx_data->morph[i].morph_panel),sizeof(BYTE),1,infile);
      fread(&(pmx_data->morph[i].morph_kind),sizeof(BYTE),1,infile);
      pmx_data->morph[i].morph_offset_count=fget_bytes_as_int(4,infile);
      if(pmx_data->morph[i].morph_offset_count>0){
        switch(pmx_data->morph[i].morph_kind){
        case 0:// O[v
        case 9:// tbv
          pmx_data->morph[i].morph_offset_data=
            new t_pmx_morph_offset_group[pmx_data->morph[i].morph_offset_count];
          break;
        case 1: // _
          pmx_data->morph[i].morph_offset_data=
            new t_pmx_morph_offset_vertex[pmx_data->morph[i].morph_offset_count];
          break;
        case 2: // {[
          pmx_data->morph[i].morph_offset_data=
            new t_pmx_morph_offset_bone[pmx_data->morph[i].morph_offset_count];
          break;
        case 3: // UV
        case 4: // ǉUV1
        case 5: // ǉUV2
        case 6: // ǉUV3
        case 7: // ǉUV4
          pmx_data->morph[i].morph_offset_data=
            new t_pmx_morph_offset_uv[pmx_data->morph[i].morph_offset_count];
          break;
        case 8: // ގ
          pmx_data->morph[i].morph_offset_data=
            new t_pmx_morph_offset_material[pmx_data->morph[i].morph_offset_count];
          break;
        case 10: // CpX
          pmx_data->morph[i].morph_offset_data=
            new t_pmx_morph_offset_impulse[pmx_data->morph[i].morph_offset_count];
          break;
        default:
          err_str="sȎނ̃[t";
          err_flg=1;
        }
      }
      if(err_flg==0) for(j=0;j<pmx_data->morph[i].morph_offset_count;j++){
        switch(pmx_data->morph[i].morph_kind){
        case 0:// O[v
        case 9:// tbv
          ((t_pmx_morph_offset_group *)(pmx_data->morph[i].morph_offset_data))[j].morph_index=
            fget_bytes_as_int(pmx_data->fmtinfo_morph_index_size,infile);
          fread(&(((t_pmx_morph_offset_group *)
                   (pmx_data->morph[i].morph_offset_data))[j].morph_rate),
                sizeof(float),1,infile);
          break;
        case 1: // _
          ((t_pmx_morph_offset_vertex *)(pmx_data->morph[i].morph_offset_data))[j].vert_index=
            fget_bytes_as_int(pmx_data->fmtinfo_vertex_index_size,infile);
          fread(&(((t_pmx_morph_offset_vertex *)
                   (pmx_data->morph[i].morph_offset_data))[j].offset),
                sizeof(float3),1,infile);
          break;
        case 2: // {[
          ((t_pmx_morph_offset_bone *)(pmx_data->morph[i].morph_offset_data))[j].bone_index=
            fget_bytes_as_int(pmx_data->fmtinfo_bone_index_size,infile);
          fread(&(((t_pmx_morph_offset_bone *)
                   (pmx_data->morph[i].morph_offset_data))[j].mov),
                sizeof(float3),1,infile);
          fread(&(((t_pmx_morph_offset_bone *)
                   (pmx_data->morph[i].morph_offset_data))[j].q_rot),
                sizeof(float4),1,infile);
          break;
        case 3: // UV
        case 4: // ǉUV1
        case 5: // ǉUV2
        case 6: // ǉUV3
        case 7: // ǉUV4
          ((t_pmx_morph_offset_uv *)(pmx_data->morph[i].morph_offset_data))[j].vert_index=
            fget_bytes_as_int(pmx_data->fmtinfo_vertex_index_size,infile);
          fread(&(((t_pmx_morph_offset_uv *)
                   (pmx_data->morph[i].morph_offset_data))[j].offset),
                sizeof(float4),1,infile);
          break;
        case 8: // ގ
          ((t_pmx_morph_offset_material *)(pmx_data->morph[i].morph_offset_data))[j].material_index=
            fget_bytes_as_int(pmx_data->fmtinfo_material_index_size,infile);
          fread(&(((t_pmx_morph_offset_material *)
                   (pmx_data->morph[i].morph_offset_data))[j].offset_type),
                sizeof(BYTE),1,infile);
          fread(&(((t_pmx_morph_offset_material *)
                   (pmx_data->morph[i].morph_offset_data))[j].diffuse_color),
                sizeof(float4),1,infile);
          fread(&(((t_pmx_morph_offset_material *)
                   (pmx_data->morph[i].morph_offset_data))[j].specular_color),
                sizeof(float3),1,infile);
          fread(&(((t_pmx_morph_offset_material *)
                   (pmx_data->morph[i].morph_offset_data))[j].specularity),
                sizeof(float),1,infile);
          fread(&(((t_pmx_morph_offset_material *)
                   (pmx_data->morph[i].morph_offset_data))[j].ambient_color),
                sizeof(float3),1,infile);
          fread(&(((t_pmx_morph_offset_material *)
                   (pmx_data->morph[i].morph_offset_data))[j].edge_color),
                sizeof(float4),1,infile);
          fread(&(((t_pmx_morph_offset_material *)
                   (pmx_data->morph[i].morph_offset_data))[j].edge_size),
                sizeof(float),1,infile);
          fread(&(((t_pmx_morph_offset_material *)
                   (pmx_data->morph[i].morph_offset_data))[j].texture_factor),
                sizeof(float4),1,infile);
          fread(&(((t_pmx_morph_offset_material *)
                   (pmx_data->morph[i].morph_offset_data))[j].sphere_factor),
                sizeof(float4),1,infile);
          fread(&(((t_pmx_morph_offset_material *)
                   (pmx_data->morph[i].morph_offset_data))[j].toon_factor),
                sizeof(float4),1,infile);
          break;
        case 10: // CpX
          ((t_pmx_morph_offset_impulse *)(pmx_data->morph[i].morph_offset_data))[j].rigidbody_index=
            fget_bytes_as_int(pmx_data->fmtinfo_rigidbody_index_size,infile);
          fread(&(((t_pmx_morph_offset_impulse *)
                   (pmx_data->morph[i].morph_offset_data))[j].local_flag),
                sizeof(BYTE),1,infile);
          fread(&(((t_pmx_morph_offset_impulse *)
                   (pmx_data->morph[i].morph_offset_data))[j].velocity),
                sizeof(float3),1,infile);
          fread(&(((t_pmx_morph_offset_impulse *)
                   (pmx_data->morph[i].morph_offset_data))[j].torque),
                sizeof(float3),1,infile);
          break;
        }
      }
    }
  }
  if(err_flg==0){
    // \g
    pmx_data->disp_count=fget_bytes_as_int(4,infile);
    if(pmx_data->disp_count>0)
      pmx_data->disp = new t_pmx_disp[pmx_data->disp_count];
    ZeroMemory(pmx_data->disp, sizeof(t_pmx_disp)*pmx_data->disp_count);
    for(i=0;i<pmx_data->disp_count;i++){
      fread_TextBuf(&(pmx_data->disp[i].disp_name),infile,bEncode);
      fread_TextBuf(&(pmx_data->disp[i].disp_name_eg),infile,bEncode);
      fread(&(pmx_data->disp[i].special_flag),sizeof(BYTE),1,infile);
      pmx_data->disp[i].disp_element_count=fget_bytes_as_int(4,infile);
      if(pmx_data->disp[i].disp_element_count>0){
        pmx_data->disp[i].disp_element=new t_pmx_disp_element[pmx_data->disp[i].disp_element_count];
      }
      for(j=0;j<pmx_data->disp[i].disp_element_count;j++){
        fread(&(pmx_data->disp[i].disp_element[j].element_target),sizeof(BYTE),1,infile);
        if(pmx_data->disp[i].disp_element[j].element_target==0){ // vfΏ:{[
          pmx_data->disp[i].disp_element[j].target_index=
            fget_bytes_as_int(pmx_data->fmtinfo_bone_index_size,infile);
        } else{ // vfΏ:[t
          pmx_data->disp[i].disp_element[j].target_index=
            fget_bytes_as_int(pmx_data->fmtinfo_morph_index_size,infile);
        }
      }
    }
    // 
    pmx_data->rigidbody_count=fget_bytes_as_int(4,infile);
    if(pmx_data->rigidbody_count>0)
      pmx_data->rigidbody = new t_pmx_rigidbody[pmx_data->rigidbody_count];
    ZeroMemory(pmx_data->rigidbody, sizeof(t_pmx_rigidbody)*pmx_data->rigidbody_count);
    for(i=0;i<pmx_data->rigidbody_count;i++){
      fread_TextBuf(&(pmx_data->rigidbody[i].rigidbody_name),infile,bEncode);
      fread_TextBuf(&(pmx_data->rigidbody[i].rigidbody_name_eg),infile,bEncode);
      pmx_data->rigidbody[i].rigidbody_rel_bone_index=
        fget_bytes_as_int(pmx_data->fmtinfo_bone_index_size,infile);
      fread(&(pmx_data->rigidbody[i].rigidbody_group_index),sizeof(BYTE),1,infile);
      pmx_data->rigidbody[i].non_collision_group_flag=fget_bytes_as_int(2,infile);
      fread(&(pmx_data->rigidbody[i].shape_type),sizeof(BYTE),1,infile);
      fread(&(pmx_data->rigidbody[i].shape_size),sizeof(float3),1,infile);
      fread(&(pmx_data->rigidbody[i].pos),sizeof(float3),1,infile);
      fread(&(pmx_data->rigidbody[i].rot),sizeof(float3),1,infile);
      fread(&(pmx_data->rigidbody[i].rigidbody_weight),sizeof(float),1,infile);
      fread(&(pmx_data->rigidbody[i].rigidbody_pos_dim),sizeof(float),1,infile);
      fread(&(pmx_data->rigidbody[i].rigidbody_rot_dim),sizeof(float),1,infile);
      fread(&(pmx_data->rigidbody[i].rigidbody_recoil),sizeof(float),1,infile);
      fread(&(pmx_data->rigidbody[i].rigidbody_friction),sizeof(float),1,infile);
      fread(&(pmx_data->rigidbody[i].rigidbody_type),sizeof(BYTE),1,infile);
    }
    // Joint
    pmx_data->joint_count=fget_bytes_as_int(4,infile);
    if(pmx_data->joint_count>0)
      pmx_data->joint = new t_pmx_joint[pmx_data->joint_count];
    ZeroMemory(pmx_data->joint, sizeof(t_pmx_joint)*pmx_data->joint_count);
    for(i=0;i<pmx_data->joint_count;i++){
      fread_TextBuf(&(pmx_data->joint[i].joint_name),infile,bEncode);
      fread_TextBuf(&(pmx_data->joint[i].joint_name_eg),infile,bEncode);
      fread(&(pmx_data->joint[i].joint_kind),sizeof(BYTE),1,infile);
      pmx_data->joint[i].rigidbodyA_index=
        fget_bytes_as_int(pmx_data->fmtinfo_rigidbody_index_size,infile);
      pmx_data->joint[i].rigidbodyB_index=
        fget_bytes_as_int(pmx_data->fmtinfo_rigidbody_index_size,infile);
      fread(&(pmx_data->joint[i].pos),sizeof(float3),1,infile);
      fread(&(pmx_data->joint[i].rot),sizeof(float3),1,infile);
      fread(&(pmx_data->joint[i].constrain_pos_L),sizeof(float3),1,infile);
      fread(&(pmx_data->joint[i].constrain_pos_U),sizeof(float3),1,infile);
      fread(&(pmx_data->joint[i].constrain_rot_L),sizeof(float3),1,infile);
      fread(&(pmx_data->joint[i].constrain_rot_U),sizeof(float3),1,infile);
      fread(&(pmx_data->joint[i].spring_pos),sizeof(float3),1,infile);
      fread(&(pmx_data->joint[i].spring_rot),sizeof(float3),1,infile);
    }
    // ()
  }
  if(infile!=nullptr) fclose(infile);
  if(err_flg) destroy_pmx_data(pmx_data);
  if(rtn_err_str!=nullptr) *rtn_err_str=err_str;
  return pmx_data;
}

void destroy_pmx_data(t_pmx_data *pmx_data){
  int i;

  if(pmx_data){
    // f
    delete[] pmx_data->model_name.aWChar;
    delete[] pmx_data->model_name_eg.aWChar;
    delete[] pmx_data->comment.aWChar;
    delete[] pmx_data->comment_eg.aWChar;
    // _
    for(i=0;i<pmx_data->vert_count;i++){
      delete[] pmx_data->vertex[i].append_uv;
      delete pmx_data->vertex[i].deform_data;
    }
    delete[] pmx_data->vertex;
    // 
    delete[] pmx_data->face_vert_index;
    // eNX`
    for(i=0;i<pmx_data->texture_count;i++){
      delete[] pmx_data->texture_path[i].aWChar;
    }
    delete[] pmx_data->texture_path;
    // ގ
    for(i=0;i<pmx_data->material_count;i++){
      delete[] pmx_data->material[i].material_name.aWChar;
      delete[] pmx_data->material[i].material_name_eg.aWChar;
      delete[] pmx_data->material[i].memo.aWChar;
    }
    delete[] pmx_data->material;
    // {[
    for(i=0;i<pmx_data->bone_count;i++){
      delete[] pmx_data->bone[i].bone_name.aWChar;
      delete[] pmx_data->bone[i].bone_name_eg.aWChar;
      if(pmx_data->bone[i].ik_data)
        delete[] pmx_data->bone[i].ik_data->ik_link;
      delete pmx_data->bone[i].ik_data;
    }
    delete[] pmx_data->bone;
    // [t
    for(i=0;i<pmx_data->morph_count;i++){
      delete[] pmx_data->morph[i].morph_name.aWChar;
      delete[] pmx_data->morph[i].morph_name_eg.aWChar;
      delete[] pmx_data->morph[i].morph_offset_data;
    }
    delete[] pmx_data->morph;
    // \g
    for(i=0;i<pmx_data->disp_count;i++){
      delete[] pmx_data->disp[i].disp_name.aWChar;
      delete[] pmx_data->disp[i].disp_name_eg.aWChar;
      delete[] pmx_data->disp[i].disp_element;
    }
    delete[] pmx_data->disp;
    // 
    for(i=0;i<pmx_data->rigidbody_count;i++){
      delete[] pmx_data->rigidbody[i].rigidbody_name.aWChar;
      delete[] pmx_data->rigidbody[i].rigidbody_name_eg.aWChar;
    }
    delete[] pmx_data->rigidbody;
    // Joint
    for(i=0;i<pmx_data->joint_count;i++){
      delete[] pmx_data->joint[i].joint_name.aWChar;
      delete[] pmx_data->joint[i].joint_name_eg.aWChar;
    }
    delete[] pmx_data->joint;
    // 
    for(i=0;i<pmx_data->softbody_count;i++){
      delete[] pmx_data->softbody[i].softbody_name.aWChar;
      delete[] pmx_data->softbody[i].softbody_name_eg.aWChar;
      delete[] pmx_data->softbody[i].anchor_rigidbody;
    }
    delete[] pmx_data->softbody;
    // PMXf[^{
    delete pmx_data;
  }
}
